#include "Sprite.h"
#include "Chars.h"
#include "VVram.h"
#include "Vram.h"

extern byte[] SpriteChars;

constexpr byte InvalidY = 0xe0;

struct Sprite {
    byte x, y;
    byte oldX, oldY;
    byte[4] chars;
};
Sprite[SpriteCount] Sprites;

void HideAllSprites()
{
    ptr<Sprite> p;
    for (p : Sprites) {
        p->y = InvalidY;
        p->oldY = InvalidY;
    }
}


void ShowSprite(ptr<Movable> pMovable, byte code)
{
    ptr<Sprite> p;
    ptr<byte> pSource, pDestination;
    p = Sprites + pMovable->sprite;
    p->x = pMovable->x;
    p->y = pMovable->y;
    pSource = SpriteChars + code;
    pDestination = p->chars;
    repeat(4) {
        *pDestination = *pSource;
        ++pSource;
        ++pDestination;
    }
}


void HideSprite(byte index) 
{
    ptr<Sprite> p;
    p = Sprites + index;
    p->y = InvalidY;
}


void EraseSprites() 
{
    ptr<Sprite> p;
    for (p : Sprites) {
        if (p->oldY != InvalidY && (
            p->oldX != p->x || 
            p->oldY != p->y
        )) {
            word offset;
            ptr<byte> pFront, pBack;
            byte y;
            y = p->oldY;
            offset = VVramOffset(p->oldX, y);
            pFront = VVramFront + offset;
            pBack = VVramBack + offset;
            pFront[0] = pBack[0];
            pFront[1] = pBack[1];
            pFront[VVramWidth] = pBack[VVramWidth];
            pFront[VVramWidth + 1] = pBack[VVramWidth + 1];
            SetRowFlags(y, 3);
        }
    }
}


void DrawSprites()
{
    ptr<Sprite> p;
    for (p : Sprites) {
        if (p->y != InvalidY) {
            ptr<byte> pFront, pChar;
            byte y;
            y = p->y;
            pFront = VVramFront + VVramOffset(p->x, y);
            pChar = p->chars;
            pFront[0] = *pChar; 
            ++pChar; pFront[1] = *pChar;
            ++pChar; pFront[VVramWidth] = *pChar;
            ++pChar; pFront[VVramWidth + 1] = *pChar;
            SetRowFlags(y, 3);
        }
        p->oldX = p->x;
        p->oldY = p->y;
    }
}
